 //  #define debug;
 
 #include <Servo.h>   // Die Servobibliothek wird aufgerufen. Sie wird benötigt, damit die Ansteuerung des Servos vereinfacht wird.
 Servo servofahne;    //Erstellt fuer das Programm einen Servo mit dem Namen "servofahne"

int randm = 4;        // Nicht verbundener Pin zum Einlesen für randomSeed.
int taster = 5;       // Das Wort "taster" steht jetzt für den Pin 5.
int LEDrot0 = 6;      // Das Wort "LEDrot0" steht jetzt für den Pin 6 -> Bereitschaftsanzeige.
int LEDrot1 = 7;      // Das Wort "LEDrot1" steht jetzt für den Pin 7.
int LEDrot2 = 8;      // Das Wort "LEDrot2" steht jetzt für den Pin 8.
int servo  = 11;      // Das Wort "servo" steht jetzt für den Pin 11.
int wiederholg = 60;  // Der Wert in dem Wort "Wiederholg" gibt an, wie oft die Bewegung im Programm ausgeführt wird.
int winkel_Min = 60;  // Linke Grenze der Servostellung.
int winkel_Max = 90;  // Rechte Grenze der Servostellung (= Mittelposition).
int warten_Min = 30;  // Kleinstmögliche Wartezeit des Programms auf den Servo.
int warten_Max = 50;  // Grösstmögliche Wartezeit des Programms auf den Servo.
int ii = 1;           // Die Variable "ii" zählt, wie oft die Schleife "Wiederholung" durchlaufen wird.
int alt;              // Hilfsspeicher 1 für Zufallszahlen
int neu;              // Hilfsspeicher 2 für Zufallszahlen
int tasterstatus = 0; // Das Wort "tasterstatus" steht jetzt zunachst für den Wert 0.
                      // Später wird unter dieser Variable gespeichert, ob der Taster gedrückt ist oder nicht.

                 
void setup()                     // Hier beginnt das Setup, es wird nur einmal beim Starten des Arduino ausgeführt.
{ // Setup the Serial port. see http://arduino.cc/en/Serial/IfSerial
  Serial.begin(9600);  
  pinMode(LEDrot0, OUTPUT);      // Der Pin mit der LED (Pin 6) ist jetzt ein Ausgang.
  pinMode(LEDrot1, OUTPUT);      // Der Pin mit der LED (Pin 7) ist jetzt ein Ausgang.
  pinMode(LEDrot2, OUTPUT);      // Der Pin mit der LED (Pin 8) ist jetzt ein Ausgang.
  pinMode(servo,   OUTPUT);      // Der Pin mit dem Servo (Pin 11) ist jetzt ein Ausgang.
  pinMode(randm,   INPUT );      // Der unbelegte Pin 4 ist jetzt ein Eingang.   
  pinMode(taster,  INPUT );      // Der Pin mit dem Taster (Pin 5) ist jetzt ein Eingang.
  servofahne.attach(servo);      // Die Steuerleitung des Servos (weiss) wird mit Pin 11 verbunden.
  servofahne.write(90);          // Mittelstellung anfahren.
  digitalWrite(LEDrot0, HIGH);   // Nun sollen alle
  digitalWrite(LEDrot1, HIGH);   // drei Leds leuchten      
  digitalWrite(LEDrot2, HIGH);   // als Funktionstest.
  randomSeed(analogRead(randm)); // Zufallszahlengenerator einschalten durch Abfragen des undefinierten Zustands von Pin 4.
  delay(1000);                   // Alle drei Leds leuchten für eine Sekunde, dann kann es losgehen.
  digitalWrite(LEDrot0, LOW);    // Nun sollen alle
  digitalWrite(LEDrot1, LOW);    // drei Leds leuchten      
  digitalWrite(LEDrot2, LOW);    // als Funktionstest. 

}

void loop()
{                                                            // Mit dieser Klammer wird der Loop-Teil geöffnet. Er wird wiederholt, bis der Strom abgestellt wird.
  tasterstatus = digitalRead(taster);                        // Hier wird der Pin 5 ausgelesen (Befehl:digitalRead).
                                           //Das Ergebnis wird unter der Variable "tasterstatus" mit dem Wert "HIGH" für 5 Volt oder "LOW" für 0 Volt gespeichert.
  if (tasterstatus == HIGH)                                  // Verarbeitung: Wenn der Taster gedrückt ist (Das Spannungssignal ist hoch), dann
  {                                                          // den Programmabschnitt des IF-Befehls öffnen.   
     digitalWrite(LEDrot0, LOW);                             // Die Bereitschaftsanzeige soll aus sein: Ein Tastendruck ist jetzt wirkungslos.
     digitalWrite(LEDrot1, HIGH);                            // Startsequenz:
     digitalWrite(LEDrot2, HIGH);                            // Led 1 und Led 2 an. 
     neu = random(winkel_Min,winkel_Max);                    // Zufallszahl zwischen winkel_Min und winkel_Max erzeugen und in "neu" abspeichern.
     bewege(winkel_Max, neu, random(warten_Min,warten_Max)); // Von Mittelstellung bis neu mit zufällig langen Wartezeiten bewegen.
     for (ii = 1; ii <= wiederholg; ii++)                    // Wiederhole soviele Male, wie in "Wiederholung" angegeben ist,
         {
            alt = neu;                                       // Start in der letzten angefahrenen Position.
            neu = random(winkel_Min,winkel_Max);             // Ende in einer zufällig erzeugten Position.
            bewege(alt, neu, random(warten_Min,warten_Max)); // Mit zufällig erzeugter Wartezeit.
         }
     digitalWrite(LEDrot1, HIGH);                            // Schlusssequenz:
     digitalWrite(LEDrot2, HIGH);                            // Zwei Leds an
     alt = neu;                                              // Abschluss: Start in der letzten angefahrenen Position.
     bewege(alt, winkel_Max, random(warten_Min,warten_Max)); // Ende in der Mittelposition.
     digitalWrite(LEDrot1, LOW );                            // Alles abgearbeitet:
     digitalWrite(LEDrot2, LOW );                            // Zwei Leds aus.    
     delay(10000);                                           // Pause von 10 Sekunden, damit nicht laufend gedrückt wird.
  }
  else                                                       // ...ansonsten...
  { //Programmabschnitt des else-Befehls oeffnen.}
     digitalWrite(LEDrot1, LOW);                             // ...sollen LED 1 
     digitalWrite(LEDrot2, LOW);                             // und Led 2 aus sein.
     digitalWrite(LEDrot0, HIGH);                            // Die Bereitschaftsanzeige soll an sein: Ein Tastendruck startet die Fahnenbewegung.
     // servofahne.write(90);                                   // Servo Position Mitte ansteuern mit dem Winkel 90°.
  }                                                          // Programmabschnitt des else-Befehls schliessen.
}


void bewege ( int von, int bis, int dauer)
{ 
  int pos;                                    // Interner Grad-Zähler.
  if (von <= bis)                             // Bewegung kleinere nach größerer Zahl?
     {
        digitalWrite(LEDrot1, LOW);           // Hin: LED 1 aus,           
        digitalWrite(LEDrot2, HIGH);          // und Led 2 an.
        for (pos = von; pos <= bis; pos += 1) // Aufwärts zählen.
            { 
               servofahne.write(pos);         // pos (in Grad) ansteuern.
               delay(dauer);                  // Warten bis der Servo soweit ist.
            }    
     }
  else                                        // Bewegung größere nach kleinerer Zahl.
     { 
        digitalWrite(LEDrot1, HIGH);          // Her: LED 1 an,           
        digitalWrite(LEDrot2, LOW );          // und Led 2 aus.
        for (pos = von; pos >= bis; pos -= 1) // Abwärts zählen.
            {
               servofahne.write(pos);         // pos in Grad ansteuern.
               delay(dauer);                  // Warten bis der Servo soweit ist.
            }  
     }
}
